@import "../abstracts/variables";
@import "../abstracts/colors";
@import "../abstracts/poppin_font_variables";

.button {
	position: relative;
	font-family: $font-family;
	font-weight: 600;
	color: $color-dark-orange;
	padding: calc(1rem * 0.8);
	background-color: $color-floral-white;
	border-radius: $border-radius;
	text-transform: capitalize;
	cursor: pointer;
	border: 1px solid $color-dark-orange;
	will-change: color;
	transition: color 0.3s 0s ease-out;
	overflow: hidden;

	&:before {
		content: ' ';
		position: absolute;
		top: 50%;
		left: 50%;
		width: 80px;
		min-height: 80px;
		background-color: $color-dark-orange;
		transform-origin: center center;
		border-radius: 10rem;
		transform: translate(-50%, -50%) scale(0.001);
		will-change: opacity, transform;
		transition-property: opacity, transform;
		transition-duration: 0.275s;
		transition-timing-function: ease-in-out;
		opacity: 0.45;
		z-index: 0;
	}

	&__content {
		position: relative;
		z-index: 1;
		text-align: center;
	}

	.icon {
		position: relative;
		width: 100%;
		height: 100%;
	}

	&:hover {
		color: $color-floral-white;

		.icon {
			background-color: $color-floral-white;
		}

		&:before {
			transform: translate(-50%, -50%) scale(2);
			opacity: 1;
		}
	}

	&--blue-green {
		color: $color-middle-blue-green;
		border-color: $color-middle-blue-green;

		&:before {
			background-color: $color-middle-blue-green;
		}
	}

	&--blue-green-inverse {
		transition-property: color, background-color;
		color: $color-floral-white;
		border-color: $color-floral-white;
		background-color: $color-middle-blue-green;

		&:before {
			background-color: $color-floral-white;
		}

		&:hover {
			color: $color-middle-blue-green;
			border-color: $color-middle-blue-green;
		}
	}

	&--sea-green {
		color: $color-light-sea-green;
		border-color: $color-light-sea-green;

		&:before {
			background-color: $color-light-sea-green;
		}
		.icon {
			background-color: $color-light-sea-green;
		}
	}

	&--sea-green-inverse {
		transition-property: color, background-color;
		color: $color-floral-white;
		border-color: $color-floral-white;
		background-color: $color-light-sea-green;

		&:before {
			background-color: $color-floral-white;
		}

		&:hover {
			color: $color-light-sea-green;
			border-color: $color-light-sea-green;
		}
	}

	&--inverse {
		transition-property: color, background-color;
		color: $color-floral-white;
		border-color: $color-floral-white;
		background-color: $color-dark-orange;

		&:before {
			background-color: $color-floral-white;
		}

		&:hover {
			color: $color-dark-orange;
			border-color: $color-dark-orange;
		}
	}
}

input[type='submit'] {
	@extend .button;

	transition-property: background-color, color;

	&:hover {
		color: $color-floral-white;
		background-color: $color-dark-orange;
	}

	&.blue-green {
		color: $color-middle-blue-green;
		border-color: $color-middle-blue-green;

		&:hover {
			color: $color-floral-white;
			background-color: $color-middle-blue-green;
		}
	}

	&.sea-green {
		color: $color-light-sea-green;
		border-color: $color-light-sea-green;

		&:hover {
			color: $color-floral-white;
			background-color: $color-light-sea-green;
		}
	}

	&.inverse {
		color: $color-floral-white;
		background-color: $color-dark-orange;
		border-color: $color-floral-white;

		&:hover {
			color: $color-dark-orange;
			border-color: $color-dark-orange;
			background-color: $color-floral-white;
		}
	}

	&.blue-green-inverse {
		color: $color-floral-white;
		background-color: $color-middle-blue-green;
		border-color: $color-floral-white;

		&:hover {
			color: $color-middle-blue-green;
			border-color: $color-middle-blue-green;
			background-color: $color-floral-white;
		}
	}

	&.sea-green-inverse {
		color: $color-floral-white;
		background-color: $color-light-sea-green;
		border-color: $color-floral-white;

		&:hover {
			color: $color-light-sea-green;
			border-color: $color-light-sea-green;
			background-color: $color-floral-white;
		}
	}
}
